package net.npaka.adapterex;
import java.util.ArrayList;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;

//リストビューとグリッドビューとギャラリー
public class AdapterEx extends Activity 
    implements View.OnClickListener {
    private final static int WC=LinearLayout.LayoutParams.WRAP_CONTENT;
    public static ArrayList<AdapterItem> items;
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //要素の情報群の生成(1)
        items=new ArrayList<AdapterItem>();
        for (int i=0;i<30;i++) {
            AdapterItem item=new AdapterItem();
            item.icon=res2bmp(this,R.drawable.ic_launcher);
            item.text="項目"+i;
            items.add(item);
        }        

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //ボタンの生成
        layout.addView(makeButton("リストビュー","listView"));
        layout.addView(makeButton("グリッドビュー","gridView"));
        layout.addView(makeButton("ギャラリー","gallery"));
    }
    
    //ボタンの生成
    private Button makeButton(String text,String tag) {
        Button button=new Button(this);
        button.setText(text);
        button.setTag(tag);
        button.setOnClickListener(this);
        button.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        return button;
    }    
    
    //ボタンクリック時に呼ばれる
    public void onClick(View v) {
        String tag=(String)v.getTag();
        if (tag.equals("listView")) {
            Intent intent=new Intent(this,ListViewActivity.class);
            startActivity(intent);
        } else if (tag.equals("gridView")) {
            Intent intent=new Intent(this,GridViewActivity.class);
            startActivity(intent);
        } else if (tag.equals("gallery")) {
            Intent intent=new Intent(this,GalleryActivity.class);
            startActivity(intent);
        }
    }    
    
    //リソース→ビットマップ
    public Bitmap res2bmp(Context context,int resID) {
        return BitmapFactory.decodeResource(
            context.getResources(),resID);
    }
}