package net.npaka.adapterex;
import java.util.ArrayList;
import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.BaseAdapter;
import android.widget.Gallery;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

//ギャラリー
public class GalleryActivity extends Activity {
    private ArrayList<AdapterItem> items;
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //要素の情報群の取得
        items=AdapterEx.items;

        //ギャラリーの生成(7)
        Gallery gallery=new Gallery(this);
        gallery.setBackgroundColor(Color.WHITE);
        gallery.setSpacing(2);
        gallery.setAdapter(new GalleryArrayAdapter());
        setContentView(gallery);
    }
    
    //リソース→ビットマップ
    public static Bitmap res2bmp(Context context,int resID) {
        return BitmapFactory.decodeResource(
            context.getResources(),resID);
    }
    
    //ギャラリー配列アダプタ
    private class GalleryArrayAdapter extends BaseAdapter {
        //数の取得
        @Override
        public int getCount() {
            return items.size();
        }
        
        //要素の取得
        @Override
        public Object getItem(int pos) {
            return items.get(pos);
        }

        //要素IDの取得
        @Override
        public long getItemId(int pos) {
            return pos;
        }
        
        //セルのビューの生成
        @Override
        public View getView(int pos,
            View convertView,ViewGroup parent) {
            Context context=GalleryActivity.this;
            AdapterItem item=items.get(pos);
            
            //レイアウトの生成
            if (convertView==null) {
                LinearLayout layout=new LinearLayout(context);
                layout.setPadding(10,10,10,10);
                layout.setOrientation(LinearLayout.VERTICAL);
                layout.setGravity(Gravity.CENTER);
                convertView=layout;

                //アイコン
                ImageView imageView=new ImageView(context);
                imageView.setTag("icon");
                imageView.setLayoutParams(new LinearLayout.LayoutParams(240,240));
                layout.addView(imageView);
                
                //テキストの指定
                TextView textView=new TextView(context);
                textView.setTag("text");
                textView.setTextColor(Color.rgb(0,0,0));
                textView.setGravity(Gravity.CENTER);
                layout.addView(textView);
            }
            
            //値の指定
            ImageView imageView=(ImageView)
                convertView.findViewWithTag("icon");
            imageView.setImageBitmap(item.icon);
            TextView textView=(TextView)
            convertView.findViewWithTag("text");
            textView.setText(item.text);
            return convertView;
        }
    }
}