package net.npaka.webviewex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.os.Bundle;
import android.view.Window;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;

//Webビュー
public class WebViewEx extends Activity {
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //Webビューの生成(1)
        WebView webView=new WebView(this);
        WebSettings settings=webView.getSettings();
        settings.setJavaScriptEnabled(true);
        settings.setSavePassword(false);
        settings.setSaveFormData(false);
        settings.setSupportZoom(false);

        //Webビューの通知リクエストの処理(3)
        webView.setWebViewClient(new WebViewClient(){
            //URLジャンプ時前に呼ばれる
            @Override
            public boolean shouldOverrideUrlLoading(WebView view,String url) {
                //外部ブラウザでなく内部ブラウザを利用
                return false;
            }
            
            //エラー時に呼ばれる
            @Override
            public void onReceivedError(WebView view,int errorCode,
                String description,String url) {
                showDialog(WebViewEx.this,"","通信エラーです。");
            }
        }); 
        setContentView(webView); 
        
        //HTMLの読み込み(2)
        webView.loadUrl("http://www.saturn.dti.ne.jp/~npaka/");
    }
    
    //ダイアログの表示
    private void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }
}