package net.npaka.c2dmex;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.widget.Toast;

//C2DMのブロードキャストレシーバ
public class C2DMReceiver extends BroadcastReceiver {
    //受信時に呼ばれる
    @Override
    public void onReceive(Context context,Intent intent) {
        //デバイス登録IDの受信(2)
        if (intent.getAction().equals("com.google.android.c2dm.intent.REGISTRATION")) {
            String regID=intent.getStringExtra("registration_id");
            //デバイス登録失敗
            if (intent.getStringExtra("error")!=null) {
                toast(context,"デバイス登録失敗>"+intent.getStringExtra("error"));
            } 
            //デバイス登録解除
            else if (intent.getStringExtra("unregistered")!=null) {
                toast(context,"デバイス登録解除");
            } 
            //デバイス登録完了
            else if (regID!=null) {
                //デバイス登録IDを開発者サーバに通知(3)
                toast(context,"デバイス登録完了>"+regID);
                android.util.Log.v("debug","デバイス登録完了>"+regID);
            }
        } 
        //メッセージの受信(7)
        else if (intent.getAction().equals("com.google.android.c2dm.intent.RECEIVE")) { 
            toast(context,"メッセージ>"+intent.getStringExtra("message"));
        }
    }
    
    //トーストの表示
    public static void toast(Context context,String text) {
        Toast.makeText(context,text,Toast.LENGTH_LONG).show();
    }
}