package net.npaka.loaderex;
import android.app.Activity;
import android.app.LoaderManager;
import android.content.CursorLoader;
import android.content.Loader;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.Browser;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

//ローダによるコンテンツプロバイダへのアクセス
public class LoaderEx extends Activity {
    private SimpleCursorAdapter cursorAdapter;
    
    //アクティビティ生成時に呼ばれる
    @Override
    protected void onCreate(Bundle bundle) {
        super.onCreate(bundle);

        //リストビューの設定
        ListView listView=new ListView(this);
        listView.setScrollingCacheEnabled(false);
        setContentView(listView);

        //カーソルアダプタの生成(1)
        cursorAdapter=new SimpleCursorAdapter(this,
            android.R.layout.simple_list_item_2,null,
            new String[]{
                Browser.BookmarkColumns.TITLE,
                Browser.BookmarkColumns.URL},
            new int[] {
                android.R.id.text1,
                android.R.id.text2});
        listView.setAdapter(cursorAdapter);
        
        //ローダの初期化(2)
        getLoaderManager().initLoader(0,null,new BookmarkLoader());
    }

    //ローダのコールバックの生成(3)
    private class BookmarkLoader implements 
        LoaderManager.LoaderCallbacks<Cursor> {
        //ローダ生成時に呼ばれる
        public Loader<Cursor> onCreateLoader(int id,Bundle args) {
            //ローダの生成(4)
            return new CursorLoader(LoaderEx.this,
                Browser.BOOKMARKS_URI,null,null,null,null);
        }

        //ロード完了時に呼ばれる
        public void onLoadFinished(Loader<Cursor> loader,Cursor data) {
            cursorAdapter.swapCursor(data);//(5)
        }
    
        //リセット時に呼ばれる
        public void onLoaderReset(Loader<Cursor> loader) {
            cursorAdapter.swapCursor(null);//(5)
        }
    }
}
