package net.npaka.serviceex;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;
import android.os.RemoteException;
import android.widget.Toast;

//サービスの定義(6)
public class MyService extends Service {
    private Handler handler=new Handler();
    private boolean running=false;
    private String  message="Message";

    //サービス生成時に呼ばれる
    @Override
    public void onCreate() {
        super.onCreate();
    }
    
    //サービス開始時に呼ばれる
    @Override
    public void onStart(Intent intent,int startID) {
        super.onStart(intent,startID);
        
        //ノティフィケーションの表示
        showNotification(this,R.drawable.ic_launcher,
            "自作サービスを開始しました",
            "自作サービス",
            "自作サービスを操作します");

        //サービスの開始
        Thread thread=new Thread(){
            public void run() {
                running=true;
                while (running) {
                    handler.post(new Runnable(){
                        public void run() {
                            toast(MyService.this,message);
                        }
                    });
                    try {
                        Thread.sleep(3000);
                    } catch (Exception e) {
                    }
                }
            }
        };
        thread.start();
    }
    
    //サービス停止時に呼ばれる
    @Override
    public void onDestroy() {
        running=false;
        super.onDestroy();
    }
    
    //サービス接続時に呼ばれる
    @Override
    public IBinder onBind(Intent intent) {
        return IMyServiceBinder;
    }
    
    //ノティフィケーションの表示(8)
    private static void showNotification(Context context,
        int iconID,String ticker,String title,String message) {
        //ノティフィケーションオブジェクトの生成
        Notification notification=new Notification(iconID,
            ticker,System.currentTimeMillis());
        PendingIntent intent=PendingIntent.getActivity(context,0,
            new Intent(context,ServiceEx.class),0);
        notification.setLatestEventInfo(context,title,message,intent);
        
        //ノティフィケーションマネージャの取得
        NotificationManager nm=(NotificationManager)
            context.getSystemService(Context.NOTIFICATION_SERVICE);
        
        //ノティフィケーションのキャンセル
        nm.cancel(0);
        
        //ノティフィケーションの表示
        nm.notify(0,notification);
    }

    //トーストの表示　
    private static void toast(Context context,String text) {
        Toast.makeText(context,text,Toast.LENGTH_SHORT).show();
    }
    
    //バインダの生成(7)
    private final IMyService.Stub IMyServiceBinder=new IMyService.Stub() {
        public void setMessage(String msg) throws RemoteException {
            message=msg;
        }
    };
}