package net.npaka.mediarecorderex;
import android.app.Activity;
import android.graphics.Color;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.os.Environment;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;

//音声合成
public class AudioActivity extends Activity {
    private MediaRecorder recorder; //メディアレコーダー
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //テキストビューの生成
        TextView textView=new TextView(this);
        textView.setText("録音中(BACKで終了)");
        textView.setTextSize(16.0f);
        textView.setTextColor(Color.rgb(0,0,0));
        layout.addView(textView);

        try {
            //録音の開始(1)
            recorder=new MediaRecorder();
            recorder.setAudioSource(MediaRecorder.AudioSource.MIC);
            recorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
            recorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);
            recorder.setOutputFile(
                Environment.getExternalStorageDirectory()+"/test.3gp");
            recorder.prepare();
            recorder.start();
        } catch (Exception e) {
            android.util.Log.e("debug",e.toString());
        }
    }

    //アプリの停止
    @Override
    public void onStop() {
        super.onStop();
        try {
            //録音の停止(2)
            recorder.stop();
            recorder.release();
        } catch (Exception e) {
            android.util.Log.e("debug",e.toString());
        }
    }
}