package net.npaka.mediarecorderex;
import android.app.Activity;
import android.content.Context;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.os.Environment;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.Window;

//録画
public class VideoActivity extends Activity {
    private MediaRecorder recorder;//メディアレコーダー
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(new CameraView(this));
    }
    
    //カメラビュー
    class CameraView extends SurfaceView 
        implements SurfaceHolder.Callback {
        
        //コンストラクタ
        public CameraView(Context context) {
            super(context);
            
            //サーフェイスホルダーの生成
            SurfaceHolder holder=getHolder();
            holder.addCallback(this);
            
            //プッシュバッッファの指定
            holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
        }

        //サーフェイス生成イベントの処理
        public void surfaceCreated(SurfaceHolder holder) {
            try {
                //録画の開始(3)
                recorder=new MediaRecorder(); 
                recorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);
                recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4);
                recorder.setVideoEncoder(MediaRecorder.VideoEncoder.DEFAULT);
                recorder.setOutputFile(
                    Environment.getExternalStorageDirectory()+"/test.mp4");
                recorder.setPreviewDisplay(holder.getSurface()); 
                recorder.prepare();
                recorder.start();
            } catch (Exception e) {
                android.util.Log.e("debug",e.toString());
            }
        }
        
        //サーフェイス変更イベントの処理
        public void surfaceChanged(SurfaceHolder holder,
            int format,int w,int h) {
        }
        
        //サーフェイス解放イベントの処理
        public void surfaceDestroyed(SurfaceHolder holder) {
            try {
                //録画の停止(4)
                recorder.stop();
                recorder.release();
            } catch (Exception e) {
                android.util.Log.e("debug",e.toString());
            }            
        }
    }
}
