package net.npaka.videoviewex;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.Window;
import android.widget.VideoView;
import android.widget.MediaController;
import java.io.InputStream;
import java.io.OutputStream;

//ムービーの再生
public class VideoViewEx extends Activity {
    
    //アクティビティ起動時に呼ばれる
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        try {
            //ビデオビューの生成(1)
            VideoView videoView=new VideoView(this);
            videoView.requestFocus();
            videoView.setMediaController(new MediaController(this));
            setContentView(videoView);

            //Rawリソースのファイル保存(2)
            InputStream in=getResources().openRawResource(R.raw.sample);
            in2file(this,in,"sample.mp4");
            
            //動画の再生(3)
            String path=getFilesDir()+"/sample.mp4";
            videoView.setVideoPath(path);
            videoView.start();
        } catch (Exception e) {
            android.util.Log.e("",e.toString());
        }
    }

    //入力ストリーム→ファイル
    private void in2file(Context context,
        InputStream in,String path) 
        throws Exception { 
        byte[] w=new byte[1024]; 
        OutputStream out=null;
        try {
            out=context.openFileOutput(path,
                Context.MODE_WORLD_READABLE);
            while (true) { 
                int size=in.read(w); 
                if (size<=0) break; 
                out.write(w,0,size); 
            };
            out.close();
            in.close();
        } catch (Exception e) {
            try {
                if (in !=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }
}